> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/products/web-scraper-api/targets/e-commerce/etsy.md).

# Etsy

Learn how to start scraping Etsy.

With Web Scraper API, you can scrape various types of **Etsy** pages; below is an overview of all supported scrapers and their respective `source` values. The response returns the page HTML in `content`, in the standard response structure described in [Realtime](/products/web-scraper-api/integration-methods/realtime.md) and [Push-Pull](/products/web-scraper-api/integration-methods/push-pull.md). Product pages can also be returned as structured data with `parse: true`, see [Product](#product).

{% hint style="warning" %}
For some targets our system **forces JavaScript rendering** even if you do not set `render`; those requests count as rendered traffic. The list of force-rendered targets and how to switch rendering off are in [Forcing rendering on specific pages](/products/web-scraper-api/features/js-rendering-and-browser-control.md#forcing-rendering-on-specific-pages).
{% endhint %}

<table><thead><tr><th width="250">Source</th><th>Description</th></tr></thead><tbody><tr><td><code>etsy_search</code></td><td><a href="#search"><strong>Search page</strong></a> for a search term of your choice.</td></tr><tr><td><code>etsy_product</code></td><td><a href="#product"><strong>Product page</strong></a> of a product ID of your choice. Dedicated parser available.</td></tr></tbody></table>

Any other Etsy page can be scraped by passing its `url` alone, no `source` needed.

{% hint style="info" %}
Besides the parameters listed below, you can include additional parameters such as `user_agent_type`, `geo_location`, `render`, and more to customize your scraping request. Read more [here](/products/web-scraper-api/features.md).
{% endhint %}

## Search

### Request samples

{% tabs %}
{% tab title="cURL" %}

```bash
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "etsy_search",
        "query": "earrings"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
    'source': 'etsy_search',
    'query': 'earrings'
}

# Get response.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# Instead of response with job status and results url, this will return the
# JSON response with the result.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "etsy_search",
    query: "earrings"
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
# The whole string you submit has to be URL-encoded.

https://realtime.oxylabs.io/v1/queries?source=etsy_search&query=earrings&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'etsy_search',
    'query' => 'earrings'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{}{
        "source": "etsy_search",
        "query": "earrings",
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://realtime.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}

```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "etsy_search",
                query = "earrings"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "etsy_search");
        jsonObject.put("query", "earrings");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "etsy_search",
    "query": "earrings"
}
```

{% endtab %}
{% endtabs %}

### Request parameter values <a href="#request-parameter-values" id="request-parameter-values"></a>

<table><thead><tr><th width="180">Parameter</th><th>Description</th><th width="160">Default Value</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>source</code></strong></mark></td><td>Sets the scraper.</td><td><code>etsy_search</code></td></tr><tr><td><mark style="background-color:green;"><strong><code>query</code></strong></mark></td><td>The keyword or phrase to search for products.</td><td>-</td></tr><tr><td><code>start_page</code></td><td>Starting page number.</td><td>1</td></tr><tr><td><code>store_id</code></td><td>Optional shop-location filter, see <a href="#localization-and-filtering">Localization and Filtering</a>.</td><td>-</td></tr></tbody></table>

&#x20;   \- mandatory parameter

## Product <a href="#product" id="product"></a>

### Request samples

{% tabs %}
{% tab title="cURL" %}

```bash
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "etsy_product",
        "product_id": "1858266469",
        "parse": true
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
    'source': 'etsy_product',
    'product_id': '1858266469',
    'parse': True
}

# Get response.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# Instead of response with job status and results url, this will return the
# JSON response with the result.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "etsy_product",
    product_id: "1858266469",
    parse: true
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
# The whole string you submit has to be URL-encoded.

https://realtime.oxylabs.io/v1/queries?source=etsy_product&product_id=1858266469&parse=true&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'etsy_product',
    'product_id' => '1858266469',
    'parse' => true
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{}{
        "source": "etsy_product",
        "product_id": "1858266469",
        "parse": true,
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://realtime.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "etsy_product",
                product_id = "1858266469",
                parse = true
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "etsy_product");
        jsonObject.put("product_id", "1858266469");
        jsonObject.put("parse", true);

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "etsy_product",
    "product_id": "1858266469",
    "parse": true
}
```

{% endtab %}
{% endtabs %}

### Request parameter values <a href="#request-parameter-values" id="request-parameter-values"></a>

<table><thead><tr><th width="180">Parameter</th><th>Description</th><th width="160">Default Value</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>source</code></strong></mark></td><td>Sets the scraper.</td><td><code>etsy_product</code></td></tr><tr><td><mark style="background-color:green;"><strong><code>product_id</code></strong></mark></td><td>The listing ID from the product page URL, e.g. <code>etsy.com/listing/</code><strong><code>1858266469</code></strong><code>/freshwater-pearl-drop-earringsbridal</code>.</td><td>-</td></tr><tr><td><code>parse</code></td><td>Returns parsed data when set to <code>true</code>. Explore the output data dictionary.</td><td><code>false</code></td></tr></tbody></table>

&#x20;   \- mandatory parameter

### Response example <a href="#response-example" id="response-example"></a>

A parsed product page for listing `1858266469`:

```json
{
    "results": [
        {
            "content": {
                "url": "https://www.etsy.com/listing/1858266469/freshwater-pearl-drop-earringsbridal",
                "price": 28,
                "title": "Freshwater Pearl Drop Earrings,Bridal Pearl Earrings,18K Gold Dangle Earrings,Wedding Earrings,Bridesmaid Gift,Wedding Gift,Bridal Jewelry",
                "images": [
                    "https://i.etsystatic.com/55594479/r/il/8c24e4/6566024892/il_75x75.6566024892_rdzf.jpg",
                    "https://v.etsystatic.com/video/upload/ar_1:1,c_fill,h_105,q_auto,w_105/WhatsApp_Video_2025-01-13_at_22.30.02_saxoj7.jpg",
                    "https://i.etsystatic.com/55594479/r/il/8784b7/6614140713/il_75x75.6614140713_mhgj.jpg",
                    "https://i.etsystatic.com/55594479/r/il/9febbb/6614140547/il_75x75.6614140547_6x1v.jpg",
                    "https://i.etsystatic.com/55594479/r/il/90ccaf/6566024810/il_75x75.6566024810_c7qt.jpg"
                ],
                "seller": {
                    "url": "https://www.etsy.com/shop/Divanjewelrygold?ref=shop-header-name&listing_id=1858266469&from_page=listing",
                    "title": "Divanjewelrygold",
                    "rating": 4.7059,
                    "best_seller": false,
                    "star_seller": false
                },
                "currency": "USD",
                "shipping": {
                    "from": ""
                },
                "avg_price": 33.33,
                "max_price": 36,
                "min_price": 28,
                "old_price": 35,
                "categories": [
                    {
                        "title": "Homepage"
                    },
                    {
                        "title": "Jewelry"
                    },
                    {
                        "title": "Earrings"
                    },
                    {
                        "title": "Dangle & Drop Earrings"
                    }
                ],
                "customized": false,
                "product_id": "1858266469",
                "variation_count": 3,
                "parse_status_code": 12000
            },
            "created_at": "2025-03-04 12:25:23",
            "updated_at": "2025-03-04 12:25:37",
            "page": 1,
            "url": "https://www.etsy.com/listing/1858266469/freshwater-pearl-drop-earringsbridal",
            "job_id": "7302665462838490113",
            "is_render_forced": false,
            "status_code": 200,
            "parser_type": "etsy_product"
        }
    ]
}
```

### Output data dictionary <a href="#output-data-dictionary" id="output-data-dictionary"></a>

The table below presents a detailed list of each product page element we parse, along with its description and data type. The table also includes some metadata.

<table><thead><tr><th width="237">Key</th><th width="372">Description</th><th>Type</th></tr></thead><tbody><tr><td><code>url</code></td><td>The URL of the Etsy product page.</td><td>string</td></tr><tr><td><code>price</code></td><td>The price of the product.</td><td>float</td></tr><tr><td><code>title</code></td><td>The title of the product.</td><td>string</td></tr><tr><td><code>images</code></td><td>Array of URLs to product images.</td><td>array</td></tr><tr><td><code>seller</code></td><td>The seller object, containing seller details (see below).</td><td>object</td></tr><tr><td><code>currency</code></td><td>The currency in which the price is denominated.</td><td>string</td></tr><tr><td><code>shipping</code></td><td>The shipping object, containing shipping details.</td><td>object</td></tr><tr><td><code>shipping.from</code></td><td>The origin country of shipping.</td><td>string</td></tr><tr><td><code>avg_price</code></td><td>The average price across the product variations.</td><td>float</td></tr><tr><td><code>min_price</code></td><td>The lowest price across the product variations.</td><td>float</td></tr><tr><td><code>max_price</code></td><td>The highest price across the product variations.</td><td>float</td></tr><tr><td><code>old_price</code></td><td>The previous price of the product before discount.</td><td>float</td></tr><tr><td><code>categories</code></td><td>Array of category objects to which the product belongs.</td><td>array</td></tr><tr><td><code>categories.title</code></td><td>The title of the category.</td><td>string</td></tr><tr><td><code>customized</code></td><td>Indicates whether the product can be customized.</td><td>boolean</td></tr><tr><td><code>product_id</code></td><td>The unique identifier for the product.</td><td>string</td></tr><tr><td><code>variation_count</code></td><td>The number of variations available for the product.</td><td>integer</td></tr><tr><td><code>parse_status_code</code></td><td>The status code of the parsing job. You can see the parser status codes described <strong>here</strong>.</td><td>integer</td></tr><tr><td><code>created_at</code></td><td>The timestamp when the scraping job was created.</td><td>timestamp</td></tr><tr><td><code>updated_at</code></td><td>The timestamp when the scraping job was finished.</td><td>timestamp</td></tr><tr><td><code>page</code></td><td>The page number in the pagination of results.</td><td>integer</td></tr><tr><td><code>status_code</code></td><td>The HTTP status code of the scraped page.</td><td>integer</td></tr><tr><td><code>parser_type</code></td><td>The type of parser used to extract the data.</td><td>string</td></tr><tr><td><code>job_id</code></td><td>The ID of the job associated with the scraping job.</td><td>string</td></tr></tbody></table>

#### **Seller**

<table><thead><tr><th width="237">Key (seller)</th><th width="372">Description</th><th>Type</th></tr></thead><tbody><tr><td><code>url</code></td><td>The URL of the seller's page.</td><td>string</td></tr><tr><td><code>title</code></td><td>The name of the seller.</td><td>string</td></tr><tr><td><code>rating</code></td><td>The rating score of the seller.</td><td>float</td></tr><tr><td><code>best_seller</code></td><td>Indicates whether the seller is a best seller.</td><td>boolean</td></tr><tr><td><code>star_seller</code></td><td>Indicates whether the seller is a star seller.</td><td>boolean</td></tr><tr><td><code>reviews_count</code></td><td>The number of reviews for the seller (optional).</td><td>integer</td></tr></tbody></table>

## Localization and Filtering <a href="#localization-and-filtering" id="localization-and-filtering"></a>

On search pages Etsy shows prices in the currency and language of the visitor's country. Use `geo_location` with a country name to get results for that market, for example `United Kingdom` (British English, prices in £) or `Germany` (German, prices in €). Without `geo_location`, results are served for the United States (US $). ZIP codes are not supported as a `geo_location` value on Etsy. For accepted values, see [Proxy location](/products/web-scraper-api/features/localization/proxy-location.md).

<table><thead><tr><th width="115.4765625">Parameter</th><th width="130.69921875">Applies to</th><th>Description</th><th width="90">Default</th></tr></thead><tbody><tr><td><code>store_id</code></td><td><code>etsy_search</code></td><td>Shop-location filter, as an integer. Use the location ID that Etsy adds to the search URL as <code>locationQuery</code> when you choose a shop location on the site, e.g. <code>2635167</code> for the United Kingdom or <code>6252001</code> for the United States.</td><td>-</td></tr></tbody></table>

```json
{
    "source": "etsy_search",
    "query": "earrings",
    "store_id": 2635167
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers.oxylabs.io/products/web-scraper-api/targets/e-commerce/etsy.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
